//RJA moving stuff needed to use McuFont here, so out of sight

#include "McuFont\fonts.h"
#include "McuFont\mcufont.h"
#include "McuFont\mf_font.h"

#include "McuFont\mf_font.c"
#include "McuFont\mf_bwfont.c"
#include "McuFont\mf_encoding.c"
#include "McuFont\mf_justify.c"
#include "McuFont\mf_kerning.c"
#include "McuFont\mf_rlefont.c"
#include "McuFont\mf_scaledfont.c"
#include "McuFont\mf_wordwrap.c"

//Adding function definition here for now..
static void pixel_callback(int16_t x, int16_t y, uint8_t count, uint8_t alpha, void* state);

typedef struct {
    const char* fontname;
    const char* filename;
    const char* text;
    bool justify;
    enum mf_align_t alignment;
    int width;
    int margin;
    int anchor;
    int scale;
} options_t;

typedef struct {
    options_t* options;
    uint8_t* buffer;
    uint16_t width;
    uint16_t height;
    uint16_t y;
    const struct mf_font_s* font;
} state_t;

/* Callback to render characters. */
static uint8_t character_callback(int16_t x, int16_t y, mf_char character,
    void* state)
{
    state_t* s = (state_t*)state;
    //printf("x= %d, y= %d\n", x, y);
    return mf_render_character(s->font, x, y, character, pixel_callback, state);

}

/* Callback to render lines. */
static bool line_callback(const char* line, uint16_t count, void* state)
{
    state_t* s = (state_t*)state;

    if (s->options->justify)
    {
        //printf("justified line\n");
        mf_render_justified(s->font, s->options->anchor, s->y,
            s->width - s->options->margin * 2,
            line, count, character_callback, state);
    }
    else
    {
        //printf("not justified line\n");
        mf_render_aligned(s->font, s->options->anchor, s->y,
            s->options->alignment, line, count,
            character_callback, state);
    }
    //printf("line y= %d, count=%d\n", s->y,count);
    s->y += s->font->line_height;
    return true;
}

/* Callback to just count the lines.
 * Used to decide the image height */
bool count_lines(const char* line, uint16_t count, void* state)
{
    int* linecount = (int*)state;
    (*linecount)++;
    return true;
}

